float hMargin = 160;
float vMargin = 100;

Table table;
int numRows, numColumns;
float [][] dataMatrix;
float maxValue, minValue;

float cellWidth, cellHeight;

boolean normalization = false;

String[] labelNames = new String[21];

PImage bibleText;
PImage ecText;

void setup() {
  size(1280, 720);
  surface.setResizable(true);

  table = loadTable("bible_finance.csv", "header");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  dataMatrix = new float[numColumns][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);

  for (int i=0; i<numColumns-1; i++) {
    for (int j=0; j<numRows; j++) {
      dataMatrix[i][j] = table.getFloat(j, i+1);
    }
  }

  maxValue = max2D(dataMatrix);
  minValue = min2D(dataMatrix);

  println("Max Value is " + maxValue);
  println("Min Value is " + minValue);

  labelNames[0] = "Month";
  labelNames[1] = "Year";
  labelNames[2] = "Bible";
  labelNames[3] = "Old Testament";
  labelNames[4] = "Historical Books (OT)";
  labelNames[5] = "Poetic books (OT)";
  labelNames[6] = "Prophetic books (OT)";
  labelNames[7] = "New Testament";
  labelNames[8] = "Gospels & Acts";
  labelNames[9] = "Epistles";
  labelNames[10] = "Revelation (Apocalypse)";
  labelNames[11] = "Apocrypha, pseudepigrapha";
  labelNames[12] = "Total Money Makeover";
  labelNames[13] = "Think & Grow Rich";
  labelNames[14] = "The Wealthy Barber";
  labelNames[15] = "The Money Book";
  labelNames[16] = "The Science of Getting Rich";
  labelNames[17] = "Financial Peace Revisited";
  labelNames[18] = "Women & Money";
  labelNames[19] = "Buffettology";
  labelNames[20] = "Sound Mind Investing";

  bibleText = loadImage("test.png");
  ecText = loadImage("test2.png");
}

void draw() {
  //println(mouseX, mouseY);
  background(255);
  
  image(bibleText, hMargin + cellWidth + 3, vMargin + cellHeight);
  image(ecText, hMargin + cellWidth + 3, vMargin + cellHeight*12);
  //modifying the cell size according to window size
  cellWidth = (width - hMargin*2)/numRows;
  cellHeight = (height - vMargin*2)/(numColumns-1);

  //Draw 2D Matrix
  for (int i=1; i<numColumns-1; i++) {
    for (int j=0; j<numRows; j++) {
      noStroke();
      //stroke(255);
      //strokeWeight(1);
      float greyScale = map(dataMatrix[i][j], minValue, maxValue, 255, 0);

      fill(255, greyScale);
      //fill(10);
      rect(hMargin + cellWidth*j, vMargin 
        + cellHeight*i, cellWidth, cellHeight);
    }
  }

  drawLabels();

  if (normalization == true) normalization();
  else if (normalization == false) resetData();
}